diff -urN ../VisualBoyAdvance-1.7.2/src/win32/Joypad.cpp ./src/win32/Joypad.cpp
--- ../VisualBoyAdvance-1.7.2/src/win32/Joypad.cpp	2004-05-13 23:23:26 +0900
+++ ./src/win32/Joypad.cpp	2006-06-07 06:04:21 +0900
@@ -30,8 +30,8 @@
 static char THIS_FILE[] = __FILE__;
 #endif
 
-extern USHORT joypad[4][13];
-extern USHORT motion[4];
+extern LONG_PTR joypad[4][13];
+extern LONG_PTR motion[4];
 
 /////////////////////////////////////////////////////////////////////////////
 // JoypadEditControl
@@ -46,27 +46,21 @@
 
 
 BEGIN_MESSAGE_MAP(JoypadEditControl, CEdit)
-  //{{AFX_MSG_MAP(JoypadEditControl)
-  ON_WM_CHAR()
-  //}}AFX_MSG_MAP
   ON_MESSAGE(JOYCONFIG_MESSAGE, OnJoyConfig)
   END_MESSAGE_MAP()
 
   /////////////////////////////////////////////////////////////////////////////
 // JoypadEditControl message handlers
 
-void JoypadEditControl::OnChar(UINT nChar, UINT nRepCnt, UINT nFlags) 
-{
-}
-
 LRESULT JoypadEditControl::OnJoyConfig(WPARAM wParam, LPARAM lParam)
 {
-  SetWindowLong(GetSafeHwnd(), GWL_USERDATA,((wParam<<8)|lParam));
-  SetWindowText(theApp.input->getKeyName((wParam<<8)|lParam));
-  GetParent()->GetNextDlgTabItem(this, FALSE)->SetFocus();
-  return TRUE;
+	SetWindowLongPtr( this->GetSafeHwnd(), GWLP_USERDATA, (wParam<<8) | lParam );
+	this->SetWindowText( theApp.input->getKeyName( (int)((wParam<<8)|lParam) ) );
+	GetParent()->GetNextDlgTabItem(this, FALSE)->SetFocus();
+	return TRUE;
 }
 
+
 BOOL JoypadEditControl::PreTranslateMessage(MSG *pMsg)
 {
   if(pMsg->message == WM_KEYDOWN && (pMsg->wParam == VK_ESCAPE || pMsg->wParam == VK_RETURN))
@@ -112,14 +106,11 @@
 
 
 BEGIN_MESSAGE_MAP(JoypadConfig, CDialog)
-  //{{AFX_MSG_MAP(JoypadConfig)
   ON_BN_CLICKED(ID_CANCEL, OnCancel)
   ON_BN_CLICKED(ID_OK, OnOk)
-  ON_WM_CHAR()
   ON_WM_DESTROY()
   ON_WM_TIMER()
   ON_WM_KEYDOWN()
-  //}}AFX_MSG_MAP
   END_MESSAGE_MAP()
 
   /////////////////////////////////////////////////////////////////////////////
@@ -137,10 +128,6 @@
   EndDialog(TRUE);
 }
 
-void JoypadConfig::OnChar(UINT nChar, UINT nRepCnt, UINT nFlags) 
-{
-}
-
 void JoypadConfig::OnDestroy() 
 {
   CDialog::OnDestroy();
@@ -148,7 +135,7 @@
   KillTimer(timerId);
 }
 
-void JoypadConfig::OnTimer(UINT nIDEvent) 
+void JoypadConfig::OnTimer(UINT_PTR nIDEvent) 
 {
   theApp.input->checkDevices();
   
@@ -163,45 +150,45 @@
 {
   CDialog::OnInitDialog();
   
-  timerId = SetTimer(0,200,NULL);
+  timerId = SetTimer(0,50,NULL);
   
-  SetWindowLong(up, GWL_USERDATA,joypad[which][KEY_UP]);
+  SetWindowLongPtr(up, GWLP_USERDATA,joypad[which][KEY_UP]);
   up.SetWindowText(theApp.input->getKeyName(joypad[which][KEY_UP]));
   
-  SetWindowLong(down, GWL_USERDATA,joypad[which][KEY_DOWN]);
+  SetWindowLongPtr(down, GWLP_USERDATA,joypad[which][KEY_DOWN]);
   down.SetWindowText(theApp.input->getKeyName(joypad[which][KEY_DOWN]));
 
-  SetWindowLong(left, GWL_USERDATA,joypad[which][KEY_LEFT]);
+  SetWindowLongPtr(left, GWLP_USERDATA,joypad[which][KEY_LEFT]);
   left.SetWindowText(theApp.input->getKeyName(joypad[which][KEY_LEFT]));
 
-  SetWindowLong(right, GWL_USERDATA,joypad[which][KEY_RIGHT]);
+  SetWindowLongPtr(right, GWLP_USERDATA,joypad[which][KEY_RIGHT]);
   right.SetWindowText(theApp.input->getKeyName(joypad[which][KEY_RIGHT]));
 
-  SetWindowLong(buttonA, GWL_USERDATA,joypad[which][KEY_BUTTON_A]);
+  SetWindowLongPtr(buttonA, GWLP_USERDATA,joypad[which][KEY_BUTTON_A]);
   buttonA.SetWindowText(theApp.input->getKeyName(joypad[which][KEY_BUTTON_A]));
 
-  SetWindowLong(buttonB, GWL_USERDATA,joypad[which][KEY_BUTTON_B]);
+  SetWindowLongPtr(buttonB, GWLP_USERDATA,joypad[which][KEY_BUTTON_B]);
   buttonB.SetWindowText(theApp.input->getKeyName(joypad[which][KEY_BUTTON_B]));
   
-  SetWindowLong(buttonL, GWL_USERDATA,joypad[which][KEY_BUTTON_L]);
+  SetWindowLongPtr(buttonL, GWLP_USERDATA,joypad[which][KEY_BUTTON_L]);
   buttonL.SetWindowText(theApp.input->getKeyName(joypad[which][KEY_BUTTON_L]));
 
-  SetWindowLong(buttonR, GWL_USERDATA,joypad[which][KEY_BUTTON_R]);
+  SetWindowLongPtr(buttonR, GWLP_USERDATA,joypad[which][KEY_BUTTON_R]);
   buttonR.SetWindowText(theApp.input->getKeyName(joypad[which][KEY_BUTTON_R]));
   
-  SetWindowLong(buttonSelect, GWL_USERDATA,joypad[which][KEY_BUTTON_SELECT]);
+  SetWindowLongPtr(buttonSelect, GWLP_USERDATA,joypad[which][KEY_BUTTON_SELECT]);
   buttonSelect.SetWindowText(theApp.input->getKeyName(joypad[which][KEY_BUTTON_SELECT]));
 
-  SetWindowLong(buttonStart, GWL_USERDATA,joypad[which][KEY_BUTTON_START]);
+  SetWindowLongPtr(buttonStart, GWLP_USERDATA,joypad[which][KEY_BUTTON_START]);
   buttonStart.SetWindowText(theApp.input->getKeyName(joypad[which][KEY_BUTTON_START]));
 
-  SetWindowLong(speed, GWL_USERDATA,joypad[which][KEY_BUTTON_SPEED]);
+  SetWindowLongPtr(speed, GWLP_USERDATA,joypad[which][KEY_BUTTON_SPEED]);
   speed.SetWindowText(theApp.input->getKeyName(joypad[which][KEY_BUTTON_SPEED]));
   
-  SetWindowLong(capture, GWL_USERDATA,joypad[which][KEY_BUTTON_CAPTURE]);
+  SetWindowLongPtr(capture, GWLP_USERDATA,joypad[which][KEY_BUTTON_CAPTURE]);
   capture.SetWindowText(theApp.input->getKeyName(joypad[which][KEY_BUTTON_CAPTURE]));
 
-  SetWindowLong(buttonGS, GWL_USERDATA,joypad[which][KEY_BUTTON_GS]);
+  SetWindowLongPtr(buttonGS, GWLP_USERDATA,joypad[which][KEY_BUTTON_GS]);
   buttonGS.SetWindowText(theApp.input->getKeyName(joypad[which][KEY_BUTTON_GS]));
   
   CenterWindow();
@@ -210,7 +197,7 @@
                 // EXCEPTION: OCX Property Pages should return FALSE
 }
 
-void JoypadConfig::assignKey(int id, int key)
+void JoypadConfig::assignKey(int id, LONG_PTR key)
 {
   switch(id) {
   case IDC_EDIT_LEFT:
@@ -260,43 +247,43 @@
   int id;
 
   id = IDC_EDIT_UP;
-  assignKey(id, GetWindowLong(up, GWL_USERDATA));
+  assignKey(id, GetWindowLongPtr(up, GWLP_USERDATA));
 
   id = IDC_EDIT_DOWN;
-  assignKey(id, GetWindowLong(down, GWL_USERDATA));
+  assignKey(id, GetWindowLongPtr(down, GWLP_USERDATA));
 
   id = IDC_EDIT_LEFT;
-  assignKey(id, GetWindowLong(left, GWL_USERDATA));
+  assignKey(id, GetWindowLongPtr(left, GWLP_USERDATA));
 
   id = IDC_EDIT_RIGHT;
-  assignKey(id, GetWindowLong(right, GWL_USERDATA));
+  assignKey(id, GetWindowLongPtr(right, GWLP_USERDATA));
 
   id = IDC_EDIT_BUTTON_A;
-  assignKey(id, GetWindowLong(buttonA, GWL_USERDATA));
+  assignKey(id, GetWindowLongPtr(buttonA, GWLP_USERDATA));
 
   id = IDC_EDIT_BUTTON_B;
-  assignKey(id, GetWindowLong(buttonB, GWL_USERDATA));
+  assignKey(id, GetWindowLongPtr(buttonB, GWLP_USERDATA));
 
   id = IDC_EDIT_BUTTON_L;
-  assignKey(id, GetWindowLong(buttonL, GWL_USERDATA));
+  assignKey(id, GetWindowLongPtr(buttonL, GWLP_USERDATA));
 
   id = IDC_EDIT_BUTTON_R;
-  assignKey(id, GetWindowLong(buttonR, GWL_USERDATA));
+  assignKey(id, GetWindowLongPtr(buttonR, GWLP_USERDATA));
   
   id = IDC_EDIT_BUTTON_SELECT;
-  assignKey(id, GetWindowLong(buttonSelect, GWL_USERDATA));
+  assignKey(id, GetWindowLongPtr(buttonSelect, GWLP_USERDATA));
 
   id = IDC_EDIT_BUTTON_START;
-  assignKey(id, GetWindowLong(buttonStart, GWL_USERDATA));
+  assignKey(id, GetWindowLongPtr(buttonStart, GWLP_USERDATA));
 
   id = IDC_EDIT_SPEED;
-  assignKey(id, GetWindowLong(speed, GWL_USERDATA));
+  assignKey(id, GetWindowLongPtr(speed, GWLP_USERDATA));
 
   id = IDC_EDIT_CAPTURE;
-  assignKey(id, GetWindowLong(capture, GWL_USERDATA));
+  assignKey(id, GetWindowLongPtr(capture, GWLP_USERDATA));
 
   id = IDC_EDIT_BUTTON_GS;
-  assignKey(id, GetWindowLong(buttonGS, GWL_USERDATA));
+  assignKey(id, GetWindowLongPtr(buttonGS, GWLP_USERDATA));
 
   //  winSaveKeys();
 }
@@ -328,14 +315,11 @@
 
 
 BEGIN_MESSAGE_MAP(MotionConfig, CDialog)
-  //{{AFX_MSG_MAP(MotionConfig)
   ON_BN_CLICKED(ID_CANCEL, OnCancel)
   ON_BN_CLICKED(ID_OK, OnOk)
-  ON_WM_CHAR()
   ON_WM_DESTROY()
   ON_WM_KEYDOWN()
   ON_WM_TIMER()
-  //}}AFX_MSG_MAP
   END_MESSAGE_MAP()
 
   /////////////////////////////////////////////////////////////////////////////
@@ -353,10 +337,6 @@
   EndDialog( TRUE);
 }
 
-void MotionConfig::OnChar(UINT nChar, UINT nRepCnt, UINT nFlags) 
-{
-}
-
 void MotionConfig::OnDestroy() 
 {
   CDialog::OnDestroy();
@@ -370,16 +350,16 @@
   
   timerId = SetTimer(0,200,NULL);
   
-  SetWindowLong(up, GWL_USERDATA,motion[KEY_UP]);
+  SetWindowLongPtr(up, GWLP_USERDATA,motion[KEY_UP]);
   up.SetWindowText(theApp.input->getKeyName(motion[KEY_UP]));
   
-  SetWindowLong(down, GWL_USERDATA,motion[KEY_DOWN]);
+  SetWindowLongPtr(down, GWLP_USERDATA,motion[KEY_DOWN]);
   down.SetWindowText(theApp.input->getKeyName(motion[KEY_DOWN]));
 
-  SetWindowLong(left, GWL_USERDATA,motion[KEY_LEFT]);
+  SetWindowLongPtr(left, GWLP_USERDATA,motion[KEY_LEFT]);
   left.SetWindowText(theApp.input->getKeyName(motion[KEY_LEFT]));
 
-  SetWindowLong(right, GWL_USERDATA,motion[KEY_RIGHT]);
+  SetWindowLongPtr(right, GWLP_USERDATA,motion[KEY_RIGHT]);
   right.SetWindowText(theApp.input->getKeyName(motion[KEY_RIGHT]));
 
   CenterWindow();
@@ -392,14 +372,14 @@
 {
 }
 
-void MotionConfig::OnTimer(UINT nIDEvent) 
+void MotionConfig::OnTimer(UINT_PTR nIDEvent) 
 {
   theApp.input->checkDevices();
   
   CDialog::OnTimer(nIDEvent);
 }
 
-void MotionConfig::assignKey(int id, int key)
+void MotionConfig::assignKey(int id, LONG_PTR key)
 {
   switch(id) {
   case IDC_EDIT_LEFT:
@@ -422,14 +402,14 @@
   int id;
 
   id = IDC_EDIT_UP;
-  assignKey(id, GetWindowLong(up, GWL_USERDATA));
+  assignKey(id, GetWindowLongPtr(up, GWLP_USERDATA));
 
   id = IDC_EDIT_DOWN;
-  assignKey(id, GetWindowLong(down, GWL_USERDATA));
+  assignKey(id, GetWindowLongPtr(down, GWLP_USERDATA));
 
   id = IDC_EDIT_LEFT;
-  assignKey(id, GetWindowLong(left, GWL_USERDATA));
+  assignKey(id, GetWindowLongPtr(left, GWLP_USERDATA));
 
   id = IDC_EDIT_RIGHT;
-  assignKey(id, GetWindowLong(right, GWL_USERDATA));
+  assignKey(id, GetWindowLongPtr(right, GWLP_USERDATA));
 }
diff -urN ../VisualBoyAdvance-1.7.2/src/win32/Joypad.h ./src/win32/Joypad.h
--- ../VisualBoyAdvance-1.7.2/src/win32/Joypad.h	2004-05-13 22:40:44 +0900
+++ ./src/win32/Joypad.h	2006-06-07 06:04:21 +0900
@@ -41,23 +41,12 @@
   // Operations
  public:
 
-  // Overrides
-  // ClassWizard generated virtual function overrides
-  //{{AFX_VIRTUAL(JoypadEditControl)
-  //}}AFX_VIRTUAL
-
   // Implementation
  public:
   virtual BOOL PreTranslateMessage(MSG *pMsg);
   afx_msg LRESULT OnJoyConfig(WPARAM wParam, LPARAM lParam);
   virtual ~JoypadEditControl();
 
-  // Generated message map functions
- protected:
-  //{{AFX_MSG(JoypadEditControl)
-  afx_msg void OnChar(UINT nChar, UINT nRepCnt, UINT nFlags);
-  //}}AFX_MSG
-
   DECLARE_MESSAGE_MAP()
     };
 
@@ -71,7 +60,7 @@
   // Construction
  public:
   void assignKeys();
-  void assignKey(int id, int key);
+  void assignKey(int id, LONG_PTR key);
   JoypadConfig(int w, CWnd* pParent = NULL);   // standard constructor
 
   // Dialog Data
@@ -102,16 +91,15 @@
 
   // Implementation
  protected:
-  UINT timerId;
+  UINT_PTR timerId;
   int which;
 
   // Generated message map functions
   //{{AFX_MSG(JoypadConfig)
   afx_msg void OnCancel();
   afx_msg void OnOk();
-  afx_msg void OnChar(UINT nChar, UINT nRepCnt, UINT nFlags);
   afx_msg void OnDestroy();
-  afx_msg void OnTimer(UINT nIDEvent);
+  afx_msg void OnTimer(UINT_PTR nIDEvent);
   afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
   virtual BOOL OnInitDialog();
   //}}AFX_MSG
@@ -125,7 +113,7 @@
   // Construction
  public:
   void assignKeys();
-  void assignKey(int id, int key);
+  void assignKey(int id, LONG_PTR key);
   MotionConfig(CWnd* pParent = NULL);   // standard constructor
 
   // Dialog Data
@@ -149,18 +137,15 @@
  protected:
 
   // Generated message map functions
-  //{{AFX_MSG(MotionConfig)
   afx_msg void OnCancel();
   afx_msg void OnOk();
-  afx_msg void OnChar(UINT nChar, UINT nRepCnt, UINT nFlags);
   afx_msg void OnDestroy();
   virtual BOOL OnInitDialog();
   afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
-  afx_msg void OnTimer(UINT nIDEvent);
-  //}}AFX_MSG
+  afx_msg void OnTimer(UINT_PTR nIDEvent);
   DECLARE_MESSAGE_MAP()
     private:
-  UINT timerId;
+  UINT_PTR timerId;
 };
 //{{AFX_INSERT_LOCATION}}
 // Microsoft Visual C++ will insert additional declarations immediately before the previous line.
diff -urN ../VisualBoyAdvance-1.7.2/src/win32/Logging.cpp ./src/win32/Logging.cpp
--- ../VisualBoyAdvance-1.7.2/src/win32/Logging.cpp	2004-05-13 23:23:01 +0900
+++ ./src/win32/Logging.cpp	2006-06-07 06:04:21 +0900
@@ -1,6 +1,6 @@
 // VisualBoyAdvance - Nintendo Gameboy/GameboyAdvance (TM) emulator.
 // Copyright (C) 1999-2003 Forgotten
-// Copyright (C) 2004 Forgotten and the VBA development team
+// Copyright (C) 2005 Forgotten and the VBA development team
 
 // This program is free software; you can redistribute it and/or modify
 // it under the terms of the GNU General Public License as published by
@@ -225,7 +225,7 @@
   m_dma2 = (systemVerbose & 64) != 0;
   m_dma3 = (systemVerbose & 128) != 0;
   m_undefined = (systemVerbose & 256) != 0;
-  m_agbprint = (systemVerbose & 256) != 0;
+  m_agbprint = (systemVerbose & 512) != 0;
   UpdateData(FALSE);
 
   m_log.LimitText(-1);
@@ -237,7 +237,7 @@
 
 void Logging::log(const char *s)
 {
-  int size = ::SendMessage(m_log, WM_GETTEXTLENGTH, 0, 0);
+  DWORD size = (DWORD)::SendMessage(m_log, WM_GETTEXTLENGTH, 0, 0);
   m_log.SetSel(size, size);
   m_log.ReplaceSel(s);
 }
diff -urN ../VisualBoyAdvance-1.7.2/src/win32/MainWnd.cpp ./src/win32/MainWnd.cpp
--- ../VisualBoyAdvance-1.7.2/src/win32/MainWnd.cpp	2004-05-13 23:22:47 +0900
+++ ./src/win32/MainWnd.cpp	2006-08-06 21:40:35 +0900
@@ -1,6 +1,6 @@
 // VisualBoyAdvance - Nintendo Gameboy/GameboyAdvance (TM) emulator.
 // Copyright (C) 1999-2003 Forgotten
-// Copyright (C) 2004 Forgotten and the VBA development team
+// Copyright (C) 2005-2006 Forgotten and the VBA development team
 
 // This program is free software; you can redistribute it and/or modify
 // it under the terms of the GNU General Public License as published by
@@ -24,6 +24,7 @@
 #include "MainWnd.h"
 
 #include <winsock.h>
+#include <shlwapi.h>
 
 #include "FileDlg.h"
 #include "Reg.h"
@@ -52,6 +53,7 @@
 #define VBA_CONFIRM_MODE WM_APP + 100
 
 extern void remoteCleanUp();
+extern int gbHardware;
 
 /////////////////////////////////////////////////////////////////////////////
 // MainWnd
@@ -192,14 +194,14 @@
   ON_UPDATE_COMMAND_UI(ID_OPTIONS_EMULATOR_PAUSEWHENINACTIVE, OnUpdateOptionsEmulatorPausewheninactive)
   ON_COMMAND(ID_OPTIONS_EMULATOR_SPEEDUPTOGGLE, OnOptionsEmulatorSpeeduptoggle)
   ON_UPDATE_COMMAND_UI(ID_OPTIONS_EMULATOR_SPEEDUPTOGGLE, OnUpdateOptionsEmulatorSpeeduptoggle)
-  ON_COMMAND(ID_OPTIONS_EMULATOR_REMOVEINTROSGBA, OnOptionsEmulatorRemoveintrosgba)
-  ON_UPDATE_COMMAND_UI(ID_OPTIONS_EMULATOR_REMOVEINTROSGBA, OnUpdateOptionsEmulatorRemoveintrosgba)
   ON_COMMAND(ID_OPTIONS_EMULATOR_AUTOMATICALLYIPSPATCH, OnOptionsEmulatorAutomaticallyipspatch)
   ON_UPDATE_COMMAND_UI(ID_OPTIONS_EMULATOR_AUTOMATICALLYIPSPATCH, OnUpdateOptionsEmulatorAutomaticallyipspatch)
   ON_COMMAND(ID_OPTIONS_EMULATOR_AGBPRINT, OnOptionsEmulatorAgbprint)
   ON_UPDATE_COMMAND_UI(ID_OPTIONS_EMULATOR_AGBPRINT, OnUpdateOptionsEmulatorAgbprint)
   ON_COMMAND(ID_OPTIONS_EMULATOR_REALTIMECLOCK, OnOptionsEmulatorRealtimeclock)
   ON_UPDATE_COMMAND_UI(ID_OPTIONS_EMULATOR_REALTIMECLOCK, OnUpdateOptionsEmulatorRealtimeclock)
+  ON_COMMAND(ID_OPTIONS_EMULATOR_GENERICFLASHCARD, OnOptionsEmulatorGenericflashcard)
+  ON_UPDATE_COMMAND_UI(ID_OPTIONS_EMULATOR_GENERICFLASHCARD, OnUpdateOptionsEmulatorGenericflashcard)
   ON_COMMAND(ID_OPTIONS_EMULATOR_AUTOHIDEMENU, OnOptionsEmulatorAutohidemenu)
   ON_UPDATE_COMMAND_UI(ID_OPTIONS_EMULATOR_AUTOHIDEMENU, OnUpdateOptionsEmulatorAutohidemenu)
   ON_COMMAND(ID_OPTIONS_EMULATOR_REWINDINTERVAL, OnOptionsEmulatorRewindinterval)
@@ -376,6 +378,9 @@
 	ON_COMMAND(ID_CHEATS_DISABLECHEATS, OnCheatsDisablecheats)
 	ON_UPDATE_COMMAND_UI(ID_CHEATS_DISABLECHEATS, OnUpdateCheatsDisablecheats)
 	ON_COMMAND(ID_OPTIONS_VIDEO_FULLSCREENMAXSCALE, OnOptionsVideoFullscreenmaxscale)
+	ON_COMMAND(ID_OPTIONS_EMULATOR_GAMEOVERRIDES, OnOptionsEmulatorGameoverrides)
+	ON_UPDATE_COMMAND_UI(ID_OPTIONS_EMULATOR_GAMEOVERRIDES, OnUpdateOptionsEmulatorGameoverrides)
+	ON_COMMAND(ID_HELP_GNUPUBLICLICENSE, OnHelpGnupubliclicense)
 	//}}AFX_MSG_MAP
   ON_COMMAND_EX_RANGE(ID_FILE_MRU_FILE1, ID_FILE_MRU_FILE10, OnFileRecentFile)
   ON_COMMAND_EX_RANGE(ID_FILE_LOADGAME_SLOT1, ID_FILE_LOADGAME_SLOT10, OnFileLoadSlot)
@@ -414,6 +419,8 @@
   ON_UPDATE_COMMAND_UI_RANGE(ID_OPTIONS_JOYPAD_AUTOFIRE_A, ID_OPTIONS_JOYPAD_AUTOFIRE_R, OnUpdateOptionsJoypadAutofire)
   ON_MESSAGE(VBA_CONFIRM_MODE, OnConfirmMode)
   ON_MESSAGE(WM_SYSCOMMAND, OnMySysCommand)
+  ON_COMMAND(ID_OPTIONS_SOUND_HARDWAREACCELERATION, &MainWnd::OnOptionsSoundHardwareacceleration)
+  ON_UPDATE_COMMAND_UI(ID_OPTIONS_SOUND_HARDWAREACCELERATION, &MainWnd::OnUpdateOptionsSoundHardwareacceleration)
   END_MESSAGE_MAP()
 
 
@@ -422,6 +429,7 @@
 
 void MainWnd::OnClose() 
 {
+  emulating = false;
   CWnd::OnClose();
 
   delete this;
@@ -469,13 +477,40 @@
     return false;
   }
   systemSaveUpdateCounter = SYSTEM_SAVE_NOT_UPDATED;
-  theApp.cartridgeType = (int)type;
+  theApp.cartridgeType = type;
   if(type == IMAGE_GB) {
+    genericflashcardEnable = theApp.winGenericflashcardEnable;
+
+
     if(!gbLoadRom(theApp.szFile))
       return false;
+
+    gbGetHardwareType();
+
+    // used for the handling of the gb Boot Rom
+    if (gbHardware & 5)
+    {
+      char tempName[2048];
+      GetModuleFileName(NULL, tempName, 2048);
+
+      char *p = strrchr(tempName, '\\');
+      if(p)
+        *p = 0;
+    
+      strcat(tempName, "\\DMG_ROM.bin");
+
+      skipBios = theApp.skipBiosFile ? true : false;
+      gbCPUInit(tempName, theApp.useBiosFile ? true : false);
+    }
+
+    
+  
+    gbReset();
     theApp.emulator = GBSystem;
     gbBorderOn = theApp.winGbBorderOn;
     theApp.romSize = gbRomSize;
+
+
     if(theApp.autoIPS) {
       int size = gbRomSize;
       utilApplyIPS(ipsname, &gbRom, &size);
@@ -492,14 +527,11 @@
       return false;
 
     theApp.romSize = size;
-    
+   
     flashSetSize(theApp.winFlashSize);
     rtcEnable(theApp.winRtcEnable);
     cpuSaveType = theApp.winSaveType;
 
-    //    if(cpuEnhancedDetection && winSaveType == 0) {
-    //      utilGBAFindSave(rom, size);
-    //    }
     GetModuleFileName(NULL, tempName, 2048);
 
     char *p = strrchr(tempName, '\\');
@@ -532,6 +564,12 @@
                              tempName);
     if(i != (UINT)-1 && (i <= 5))
       cpuSaveType = (int)i;
+    i = GetPrivateProfileInt(buffer,
+                             "mirroringEnabled",
+                             -1,
+                             tempName);
+    if(i != (UINT)-1)
+      doMirroring (i == 0 ? false : true);
     
     theApp.emulator = GBASystem;
     /* disabled due to problems
@@ -565,7 +603,7 @@
     CPUInit((char *)(LPCTSTR)theApp.biosFileName, theApp.useBiosFile ? true : false);
     CPUReset();
   }
-  
+
   readBatteryFile();
 
   if(theApp.autoSaveLoadCheatList)
@@ -730,6 +768,16 @@
   else
     name = theApp.filename;
   CString dir = regQueryStringValue("saveDir", NULL);
+  if( dir[0] == '.' ) {
+	  // handle as relative path
+	  char baseDir[MAX_PATH+1];
+	  GetModuleFileName( NULL, baseDir, MAX_PATH );
+	  baseDir[MAX_PATH] = '\0'; // for security reasons
+	  PathRemoveFileSpec( baseDir ); // removes the trailing file name and backslash
+	  strcat( baseDir, "\\" );
+	  strcat( baseDir, dir );
+	  dir = baseDir;
+	}
 
   if(!dir.GetLength())
     dir = getDirFromFile(filename);
@@ -762,6 +810,16 @@
   else
     name = theApp.filename;
   CString dir = regQueryStringValue("saveDir", NULL);
+  if( dir[0] == '.' ) {
+	  // handle as relative path
+	  char baseDir[MAX_PATH+1];
+	  GetModuleFileName( NULL, baseDir, MAX_PATH );
+	  baseDir[MAX_PATH] = '\0'; // for security reasons
+	  PathRemoveFileSpec( baseDir ); // removes the trailing file name and backslash
+	  strcat( baseDir, "\\" );
+	  strcat( baseDir, dir );
+	  dir = baseDir;
+	}
 
   if(!dir.GetLength())
     dir = getDirFromFile(filename);
@@ -824,6 +882,16 @@
     buffer = theApp.filename;
 
   CString saveDir = regQueryStringValue("batteryDir", NULL);
+  if( saveDir[0] == '.' ) {
+	  // handle as relative path
+	  char baseDir[MAX_PATH+1];
+	  GetModuleFileName( NULL, baseDir, MAX_PATH );
+	  baseDir[MAX_PATH] = '\0'; // for security reasons
+	  PathRemoveFileSpec( baseDir ); // removes the trailing file name and backslash
+	  strcat( baseDir, "\\" );
+	  strcat( baseDir, saveDir );
+	  saveDir = baseDir;
+	}
 
   if(saveDir.IsEmpty())
     saveDir = getDirFromFile(theApp.filename);
@@ -851,6 +919,16 @@
     buffer = theApp.filename;
 
   CString saveDir = regQueryStringValue("batteryDir", NULL);
+  if( saveDir[0] == '.' ) {
+	  // handle as relative path
+	  char baseDir[MAX_PATH+1];
+	  GetModuleFileName( NULL, baseDir, MAX_PATH );
+	  baseDir[MAX_PATH] = '\0'; // for security reasons
+	  PathRemoveFileSpec( baseDir ); // removes the trailing file name and backslash
+	  strcat( baseDir, "\\" );
+	  strcat( baseDir, saveDir );
+	  saveDir = baseDir;
+	}
 
   if(saveDir.IsEmpty())
     saveDir = getDirFromFile(theApp.filename);
@@ -915,7 +993,7 @@
             info.cch = 256;
             if(!GetMenuItemInfo(theApp.menu, i, MF_BYPOSITION, &info)) {
             }
-            if(!AppendMenu(theApp.popup, MF_POPUP|MF_STRING, (UINT)info.hSubMenu, buffer)) {
+            if(!AppendMenu(theApp.popup, MF_POPUP|MF_STRING, (UINT_PTR)info.hSubMenu, buffer)) {
             }
           }
         } else {
@@ -929,7 +1007,7 @@
             info.cch = 256;
             if(!GetMenuItemInfoW(theApp.menu, i, MF_BYPOSITION, &info)) {
             }
-            if(!AppendMenuW(theApp.popup, MF_POPUP|MF_STRING, (UINT)info.hSubMenu, buffer)) {
+            if(!AppendMenuW(theApp.popup, MF_POPUP|MF_STRING, (UINT_PTR)info.hSubMenu, buffer)) {
             }
           }
         }
@@ -951,37 +1029,71 @@
   ShowWindow(SW_SHOWMINIMIZED);
 }
 
-bool MainWnd::fileOpenSelect()
+
+bool MainWnd::fileOpenSelect( bool gb )
 {
-  theApp.dir = "";
-  CString initialDir = regQueryStringValue("romdir",".");
-  if(!initialDir.IsEmpty())
-    theApp.dir = initialDir;
-
-  int selectedFilter = regQueryDwordValue("selectedFilter", 0);
-  if(selectedFilter < 0 || selectedFilter > 2)
-    selectedFilter = 0;
-
-  theApp.szFile = "";
-
-  LPCTSTR exts[] = { "" };
-  CString filter = winLoadFilter(IDS_FILTER_ROM);
-  CString title = winResLoadString(IDS_SELECT_ROM);
-
-  FileDlg dlg(this, "", filter, selectedFilter, "", exts, theApp.dir, title, false);
-
-  if(dlg.DoModal() == IDOK) {
-    regSetDwordValue("selectedFilter", dlg.m_ofn.nFilterIndex);
-    theApp.szFile = dlg.GetPathName();
-    theApp.dir = theApp.szFile.Left(dlg.m_ofn.nFileOffset);
-    if(theApp.dir.GetLength() > 3 && theApp.dir[theApp.dir.GetLength()-1] == '\\')
-      theApp.dir = theApp.dir.Left(theApp.dir.GetLength()-1);
-    regSetStringValue("romdir", theApp.dir);
-    return true;
-  }
-  return false;
+	theApp.dir = _T("");
+	CString initialDir;
+	if( gb ) {
+		initialDir = regQueryStringValue( _T("gbromdir"), _T(".") );
+	} else {
+		initialDir = regQueryStringValue( _T("romdir"), _T(".") );
+	}
+	
+	if( initialDir[0] == '.' ) {
+		// handle as relative path
+		char baseDir[MAX_PATH+1];
+		GetModuleFileName( NULL, baseDir, MAX_PATH );
+		baseDir[MAX_PATH] = '\0'; // for security reasons
+		PathRemoveFileSpec( baseDir ); // removes the trailing file name and backslash
+		strcat( baseDir, "\\" );
+		strcat( baseDir, initialDir );
+		initialDir = baseDir;
+	}
+
+	if( !initialDir.IsEmpty() ) {
+		theApp.dir = initialDir;
+	}
+
+	int selectedFilter = 0;
+	if( !gb ) {
+		selectedFilter = regQueryDwordValue( _T("selectedFilter"), 0);
+		if( (selectedFilter < 0) || (selectedFilter > 2) ) {
+			selectedFilter = 0;
+		}
+	}
+	
+	theApp.szFile = _T("");
+	
+	LPCTSTR exts[] = { _T(""), _T(""), _T(""), _T("") };
+	CString filter;
+	CString title;
+	if( gb ) {
+		filter = winLoadFilter( IDS_FILTER_GBROM );
+		title = winResLoadString( IDS_SELECT_ROM );
+	} else {
+		filter = winLoadFilter( IDS_FILTER_ROM );
+		title = winResLoadString( IDS_SELECT_ROM );
+	}
+
+	FileDlg dlg( this, _T(""), filter, selectedFilter, _T(""), exts, theApp.dir, title, false);
+
+	if( dlg.DoModal() == IDOK ) {
+		if( !gb ) {
+			regSetDwordValue( _T("selectedFilter"), dlg.m_ofn.nFilterIndex );
+		}
+		theApp.szFile = dlg.GetPathName();
+		theApp.dir = theApp.szFile.Left( dlg.m_ofn.nFileOffset );
+		if( (theApp.dir.GetLength() > 3) && (theApp.dir[theApp.dir.GetLength()-1] == _T('\\')) ) {
+			theApp.dir = theApp.dir.Left( theApp.dir.GetLength() - 1 );
+		}
+		SetCurrentDirectory( theApp.dir );
+		return true;
+	}
+	return false;
 }
 
+
 void MainWnd::OnPaint() 
 {
   CPaintDC dc(this); // device context for painting
@@ -1011,6 +1123,16 @@
   CString buffer;
   
   CString captureDir = regQueryStringValue("captureDir", "");
+  if( captureDir[0] == '.' ) {
+	  // handle as relative path
+	  char baseDir[MAX_PATH+1];
+	  GetModuleFileName( NULL, baseDir, MAX_PATH );
+	  baseDir[MAX_PATH] = '\0'; // for security reasons
+	  PathRemoveFileSpec( baseDir ); // removes the trailing file name and backslash
+	  strcat( baseDir, "\\" );
+	  strcat( baseDir, captureDir );
+	  captureDir = baseDir;
+	}
   int index = theApp.filename.ReverseFind('\\');
   
   CString name;
@@ -1039,6 +1161,15 @@
                   captureNumber,
                   ext);
 
+  // check if file exists
+  DWORD dwAttr = GetFileAttributes( buffer );
+  if( dwAttr != INVALID_FILE_ATTRIBUTES ) {
+	  // screenshot file already exists
+	  screenCapture(++captureNumber);
+	  // this will recursively use the first non-existent screenshot number
+	  return;
+  }
+
   if(theApp.captureFormat == 0)
     theApp.emulator.emuWritePNG(buffer);
   else
@@ -1098,7 +1229,12 @@
   }
 
   if(theApp.paused && emulating)
+  {
+    theApp.painting = true;
     systemDrawScreen();
+    theApp.painting = false;
+    theApp.renderedFrames--;
+  }
 }
 
 #if _MSC_VER <= 1200
@@ -1145,3 +1281,4 @@
   }
   return Default();
 }
+
diff -urN ../VisualBoyAdvance-1.7.2/src/win32/MainWnd.h ./src/win32/MainWnd.h
--- ../VisualBoyAdvance-1.7.2/src/win32/MainWnd.h	2004-05-13 22:39:34 +0900
+++ ./src/win32/MainWnd.h	2006-08-06 21:40:35 +0900
@@ -1,7 +1,7 @@
 // -*- C++ -*-
 // VisualBoyAdvance - Nintendo Gameboy/GameboyAdvance (TM) emulator.
 // Copyright (C) 1999-2003 Forgotten
-// Copyright (C) 2004 Forgotten and the VBA development team
+// Copyright (C) 2005 Forgotten and the VBA development team
 
 // This program is free software; you can redistribute it and/or modify
 // it under the terms of the GNU General Public License as published by
@@ -55,7 +55,7 @@
   void winMouseOn();
   void screenCapture(int captureNumber);
   HACCEL m_hAccelTable;
-  bool fileOpenSelect();
+  bool fileOpenSelect( bool gb = false );
   afx_msg LRESULT OnConfirmMode(WPARAM, LPARAM);
   afx_msg LRESULT OnMySysCommand(WPARAM, LPARAM);
   afx_msg void OnUpdateFileLoadGameSlot(CCmdUI *pCmdUI);
@@ -221,14 +221,14 @@
   afx_msg void OnUpdateOptionsEmulatorPausewheninactive(CCmdUI* pCmdUI);
   afx_msg void OnOptionsEmulatorSpeeduptoggle();
   afx_msg void OnUpdateOptionsEmulatorSpeeduptoggle(CCmdUI* pCmdUI);
-  afx_msg void OnOptionsEmulatorRemoveintrosgba();
-  afx_msg void OnUpdateOptionsEmulatorRemoveintrosgba(CCmdUI* pCmdUI);
   afx_msg void OnOptionsEmulatorAutomaticallyipspatch();
   afx_msg void OnUpdateOptionsEmulatorAutomaticallyipspatch(CCmdUI* pCmdUI);
   afx_msg void OnOptionsEmulatorAgbprint();
   afx_msg void OnUpdateOptionsEmulatorAgbprint(CCmdUI* pCmdUI);
   afx_msg void OnOptionsEmulatorRealtimeclock();
   afx_msg void OnUpdateOptionsEmulatorRealtimeclock(CCmdUI* pCmdUI);
+  afx_msg void OnOptionsEmulatorGenericflashcard();
+  afx_msg void OnUpdateOptionsEmulatorGenericflashcard(CCmdUI* pCmdUI);
   afx_msg void OnOptionsEmulatorAutohidemenu();
   afx_msg void OnUpdateOptionsEmulatorAutohidemenu(CCmdUI* pCmdUI);
   afx_msg void OnOptionsEmulatorRewindinterval();
@@ -408,13 +408,20 @@
   afx_msg void OnUpdateOptionsSoundVolume5x(CCmdUI* pCmdUI);
   afx_msg void OnCheatsDisablecheats();
   afx_msg void OnUpdateCheatsDisablecheats(CCmdUI* pCmdUI);
-	afx_msg void OnOptionsVideoFullscreenmaxscale();
+  afx_msg void OnOptionsVideoFullscreenmaxscale();
+  afx_msg void OnOptionsEmulatorGameoverrides();
+  afx_msg void OnUpdateOptionsEmulatorGameoverrides(CCmdUI* pCmdUI);
+	afx_msg void OnHelpGnupubliclicense();
 	//}}AFX_MSG
   DECLARE_MESSAGE_MAP()
-
+    
     afx_msg BOOL OnFileRecentFile(UINT nID);
   afx_msg BOOL OnFileLoadSlot(UINT nID);
   afx_msg BOOL OnFileSaveSlot(UINT nID);
+public:
+	afx_msg void OnOptionsSoundHardwareacceleration();
+public:
+	afx_msg void OnUpdateOptionsSoundHardwareacceleration(CCmdUI *pCmdUI);
 };
 
 /////////////////////////////////////////////////////////////////////////////
